use std::{collections::HashMap, convert::Infallible, error::Error, rc::Rc};

use crate::types::{TaggedType, TypeTag};

pub mod recursive;
#[cfg(test)]
mod test;
pub mod unification;

#[derive(Debug)]
pub enum InferError {
    NotAFunction,
    MismatchedType,
    NotInContext,
    ExpectedConreteType,
    ExpectedTypeWithTag,
    DoesNotFitTag(TypeTag, TaggedType),
    ConfilictingBind,
    ConfilictingTags,
}
